Package com.io7m.jregions.core.parameterized.areas

# Class PAreaYSplitL.Builder<S,T extends PAreaLType<S>>

java.lang.Object
com.io7m.jregions.core.parameterized.areas.PAreaYSplitL.Builder<S,T>

Enclosing class:
  PAreaYSplitL<S,T extends PAreaLType<S>>

public static final class PAreaYSplitL.Builder<S,T extends PAreaLType<S>> extends Object
Builds instances of type `PAreaYSplitL`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `PAreaYSplitL<S,T>`
  `build()`
  Builds a new `PAreaYSplitL`.
  `final PAreaYSplitL.Builder<S,T>`
  `from(PAreaYSplitLType<S,T> instance)`
  Fill a builder with attribute values from the provided `PAreaYSplitLType` instance.
  `final PAreaYSplitL.Builder<S,T>`
  `setLower(T lower)`
  Initializes the value for the `lower` attribute.
  `final PAreaYSplitL.Builder<S,T>`
  `setUpper(T upper)`
  Initializes the value for the `upper` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final PAreaYSplitL.Builder<S,T> from(PAreaYSplitLType<S,T> instance)
    Fill a builder with attribute values from the provided `PAreaYSplitLType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setLower

    public final PAreaYSplitL.Builder<S,T> setLower(T lower)
    Initializes the value for the `lower` attribute.
    Parameters:
      `lower` - The value for lower
    Returns:
      `this` builder for use in a chained invocation

  - ### setUpper

    public final PAreaYSplitL.Builder<S,T> setUpper(T upper)
    Initializes the value for the `upper` attribute.
    Parameters:
      `upper` - The value for upper
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public PAreaYSplitL<S,T> build()
    Builds a new `PAreaYSplitL`.
    Returns:
      An immutable instance of PAreaYSplitL
    Throws:
      `IllegalStateException` - if any required attributes are missing